<!--给特定渠道号用户派发免拼券 created By 1173944134@qq.com-->
<template>
    <!--toast-->
    <div class="yidialog-con yid-toast-con" id="toastCon">
        <div class="yid-back"></div>
        <div class="yid-con flex-row">
            <div class="yid-con-body flex-row">
                <!--消息-->
                <div class="msg"></div>
            </div>
        </div>
    </div>
    <!--弹窗-->
    <div class="yidialog-con" id="Dia">
        <div class="yid-back"></div>
        <div class="yid-con flex-row yid-con-col">
            <div class="yid-con-body flex-row">
                <div class="kj-djs"></div>
                <img src="" style="display: none;" class="coupon-img"/>
                <div class="btn-baom-con">
                    <img src="" class="btn-baom heart-beat"/>
                </div>
            </div>
            <div class="yid-cls-con">
                <img src="" class="yid-cls"/>
            </div>
        </div>
    </div>
</template>

<script>
    export default {
        name: 'pfmpq',
        data: {
            disMpq: ApiHelper.SERVER + '/dengta/coupon/non-grouping-coupon/distribute.json', // 派发免拼券
            courseImg: resourcePath + '/imgs/groupPurchase/newCourseImg/',
            imgPath: resourcePath + '/imgs/groupPurchase/act/luckybag/',
            pvuv: ApiHelper.SERVER + '/dengta/common/act/10029/addPvuv.json' // pvuv微信通用接口
        },
        // pvuvkey
        pvuvKey: {},
        // 接口数据
        actData: {
            status: 0 // 0-不能参加，1-可以参加，2-已购买
        },
        // 曝光统计
        sendExposePvuv: function (data, callback) {
            data = data || {}
            !data.pvuvKeyId && (data.pvuvKeyId = 947)
            data.actChannels = data.channel
            var url = this.data.pvuv
            if (!data.actId) {
                url = url.replace('10029', 10038)
            }
            delete data.channel
            if (!data.expParam) {
                data.expParam = {
                    module: '',
                    tag: ''
                }
            }
            $.get(url, data)
            callback && setTimeout(callback, 300)
        },
        addPvuv: function (data, callback) {
            ApiHelper.myLog('pvuv>>>>', data)
            $.get(data.url || this.data.pvuv, data)
            callback && setTimeout(callback, 300)
        },
        // 初始化
        init: function () {
            ApiHelper.courseDetails && this.initCourseDetails()
        },
        // 课程详情页
        initCourseDetails: function () {
            var that = this
            if (ApiHelper.getQueryString('pfmpq') !== '1') {
                return
            }
            // 已经支付
            var pageName = $('body').data('page-name')
            if (pageName === 'inviteFriends') {
                $('.btn-goto-learn').click()
                return
            }
            var courseId = ApiHelper.getQueryString('courseId')
            var channel = ApiHelper.getQueryString('state')
            $.post(this.data.disMpq, {
                courseId: courseId,
                channel: channel
            }, function (res) {
                var resData = res.value || {}
                var distributeState = resData.distributeState
                var couponId = resData.couponId
                // 免拼券已派发完
                if (!distributeState) {
                    that.showToast('没有抢到此免拼资格哦')
                    return
                }
                if (!couponId) {
                    return
                }
                location.replace('/wx/groupBuy/courseDetails.html?courseId=' + courseId + '&pfrom=nospell&couponId=' + couponId + '&state=' + channel)
            })
        },
        // toast消息
        showToast: function (msg, time, callback) {
            if ($('#toastCon').length === 0) {
                $(toastCon).appendTo($('body'))
            }
            $('#toastCon').css({
                display: 'flex'
            })
            $('#toastCon .msg').text(msg)
            setTimeout(function () {
                $('#toastCon').hide()
                callback && callback()
            }, time || 3000)
        },
        // 是否在可视区域 document.addEventListener('scroll', ApiHelper.throttle(function () {}, 500)
        isInView: function (selector) {
            if (!document.querySelector(selector)) {
                return false
            }
            var rect = document.querySelector(selector).getBoundingClientRect()
            var flag = false
            if (rect.top <= window.innerHeight && rect.top >= -rect.height) {
                flag = true
            }
            return flag
        },
        // 插入未来元素
        checkHas: function (selector, callback) {
            var that = this
            var addBannerCount = 0

            function check() {
                setTimeout(function () {
                    addBannerCount++
                    if ($(selector).length > 0) {
                        callback && callback.call(that)
                    } else {
                        addBannerCount < 5 && check()
                    }
                }, 1000)
            }

            check()
        },
        getStorageSync: function (key) {
            var storage = localStorage.getItem(key)
            try {
                storage = JSON.parse(storage)
            } catch (e) {
                storage = storage
            }
            return storage
        },
        setStorageSync: function (key, data) {
            localStorage.setItem(key, JSON.stringify(data))
        },
        //倒计时
        doubleEvelenTimeDown: function (cutDownTime) {
            var oneDay = 24 * 60 * 60 * 1000
            var that = this
            var courseTime = setInterval(function () {
                cutDownTime -= 10
                if (cutDownTime > oneDay) {
                    var hh = Math.floor(cutDownTime / 1000 / 60 / 60 % 24)
                    var dd = Math.floor(cutDownTime / 1000 / 60 / 60 / 24)
                    dd = dd > 99 ? 99 : dd
                    var mm = parseInt(cutDownTime / 1000 / 60 % 60)
                    var ss = parseInt(cutDownTime / 1000 % 60)
                    var ms = parseInt(cutDownTime / 100 % 10)
                    hh = (hh >= 0 && hh < 10) ? ("0" + hh) : hh   //时
                    mm = (mm >= 0 && mm < 10) ? ("0" + mm) : mm   //分
                    ss = (ss >= 0 && ss < 10) ? ("0" + ss) : ss   //秒
                    ms = (ms >= 0 && ms < 10) ? ("0" + ms) : ms   //秒
                    $('.countDownNum11').html('<span class="days">' + dd + '天' + '<span class="hours">' + hh + '</span><span class="time_sign">:</span><span class="hours">' + mm + '</span><span class="time_sign">:</span><span class="hours">' + ss + '</span><span class="time_sign">:</span><span class="hours">' + ms + '</span>')
                } else {
                    var hh = Math.floor(cutDownTime / 1000 / 60 / 60)
                    var mm = parseInt(cutDownTime / 1000 / 60 % 60)
                    var ss = parseInt(cutDownTime / 1000 % 60)
                    var ms = parseInt(cutDownTime / 100 % 10)
                    if (hh < 0 || mm < 0 || ss < 0 || ms < 0) {
                        hh = 0
                        mm = 0
                        ss = 0
                        ms = 0
                        clearInterval(courseTime)
                    }
                    hh = (hh >= 0 && hh < 10) ? ("0" + hh) : hh   //时
                    mm = (mm >= 0 && mm < 10) ? ("0" + mm) : mm   //分
                    ss = (ss >= 0 && ss < 10) ? ("0" + ss) : ss   //秒
                    ms = (ms >= 0 && ms < 10) ? ("0" + ms) : ms   //秒
                    $('.coupon_time_h').text(hh)
                    $('.coupon_time_m').text(mm)
                    $('.coupon_time_s').text(ss)
                    $('.coupon_time_ms').text(ms)
                }
                clearInterval(courseTime)
                that.doubleEvelenTimeDown(cutDownTime)
            }, 10)
        }
    }
</script>

<style scoped lang="less">
    .flex-row {
        display: -moz-box;
        /* 老版本语法: Firefox (buggy) */
        display: -ms-flexbox;
        /* 混合版本语法: IE 10 */
        display: -webkit-flex;
        /* 新版本语法: Chrome 21+ */
        display: flex;
    }

    @cl-mask: rgba(0, 0, 0, 0.85);
    /**弹窗**/
    .yidialog-con {
        position: fixed;
        width: 100%;
        height: 100%;
        top: 0px;
        left: 0px;
        display: flex;
        align-items: center;
        justify-content: center;
        z-index: 1000;

        .yid-back {
            position: absolute;
            left: 0px;
            top: 0px;
            width: 100%;
            height: 100%;
            text-align: center;
            background: @cl-mask;
        }

        .yid-con {
            position: relative;
            display: flex;
            justify-content: center;
            align-content: center;
            color: #ffffff;
            flex-wrap: wrap;

            .yid-cls {
                position: relative;
                z-index: 9999;
                width: 0.51rem;
                height: 0.51rem;
                flex-shrink: 0;
            }

            .yid-hand {
                position: absolute;
                width: 1rem;
                top: 3.1rem;
                right: 0.1rem;
                animation: handClick 1s infinite;
            }
        }

        .yid-con-col {
            flex-direction: column;
        }
    }

    /**toast**/
    .yid-toast-con {
        display: none;

        .yid-back {
            opacity: 0;
        }

        .yid-con {
            .yid-con-body {
                justify-content: center;
                align-items: center;

                .msg {
                    padding: 20px;
                    background-color: #333333;
                    color: #ffffff;
                    font-size: 28px;
                    border-radius: 10px;
                }
            }
        }
    }

    .my-hand-ani {
        animation: myHandAni 1s infinite;
    }

    @keyframes myHandAni {
        50% {
            left: 80px;
        }
        0%, 100% {
            left: 50px;
        }
    }

    @keyframes iconClick {
        0%, 100% {
            margin-bottotm: 0;
        }
        50% {
            margin-bottom: -35px;
            transform: scale(1.1);
        }
    }

    @keyframes handClick {
        from {
            margin-top: 0rem;
            margin-right: 0rem;
        }
        50% {
            margin-top: -0.1rem;
            margin-right: 0.1rem;
            transform: scale(0.9);
        }
        to {
            margin-top: -0rem;
            margin-right: 0rem;
        }
    }

    .scale-size {
        animation: scaleSize 2s infinite;
    }

    @keyframes scaleSize {
        from {
            transform: scale(0.9);
            opacity: 0.9;
        }
        50% {
            transform: scale(1.2);
            opacity: 1;
        }
        to {
            transform: scale(0.9);
            opacity: 0.9;
        }
    }

    .heart-beat {
        animation: heartBeat 1s infinite;
    }

    @keyframes heartBeat {
        0% {
            -webkit-transform: scale(1);
            transform: scale(1);
        }

        14% {
            -webkit-transform: scale(.8);
            transform: scale(.8);
        }

        28% {
            -webkit-transform: scale(1);
            transform: scale(1);
        }

        42% {
            -webkit-transform: scale(.8);
            transform: scale(.8);
        }

        70% {
            -webkit-transform: scale(1);
            transform: scale(1);
        }
    }

    /**淡入*/
    .fade-in {
        animation: fadeIn 1s;
    }

    @keyframes fadeIn {
        from {
            opacity: 0;
        }
        to {
            opacity: 1;
        }
    }
</style>
